package com.customization.sskj;

import com.customization.sskj.util.JobGroupUtil;
import com.engine.core.cfg.annotation.CommandDynamicProxy;
import com.engine.core.interceptor.AbstractCommandProxy;
import com.engine.core.interceptor.Command;
import com.engine.hrm.cmd.jobset.AddJobGroupCmd;
import com.engine.kq.cmd.reportdetial.GetTabsCmd;
import org.apache.commons.lang.StringUtils;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.systeminfo.SystemEnv;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 事假明细扩展tab
 */
@CommandDynamicProxy(target = GetTabsCmd.class, desc = "GetTabsCmd")
public class GetTabsCmdInter extends AbstractCommandProxy<Map<String, Object>> {

    BaseBean basebean = new BaseBean();
    @Override
    public Map<String, Object> execute(Command<Map<String, Object>> command) {

        GetTabsCmd cmd = (GetTabsCmd) command;
        User user = cmd.getUser();
        Map<String, Object> params = cmd.getParams();
        Map<String, Object> result = nextExecute(cmd);

        try {
            String calLeaveId = basebean.getPropValue("project_sskj", "calLeaveId");
            String type = Util.null2String(params.get("type"));
            if (("leaveType_"+calLeaveId).equals(type)) {
                String status = Util.null2String(result.get("status"));
                if ( status.equals("1")) {
                    Object tabsObj = result.get("tabs");
                    if (tabsObj !=null & tabsObj != "") {
                        List<Map<String, Object>> tabs = (List<Map<String, Object>>) tabsObj;
                        Map<String, Object> temp = new HashMap<>();
                        temp.put("key","3");
                        temp.put("title", SystemEnv.getHtmlLabelName(10000,user.getLanguage()));
                        tabs.add(temp);
                    }
                }
            }
        }catch (Exception e) {
            basebean.writeLog("GetTabsCmdInter Exception: " + e);
        }

        return result;
    }
}
