package weaver.interfaces.sskj.job;

import org.apache.commons.lang3.StringUtils;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.interfaces.schedule.BaseCronJob;

/**
 * Created with IntelliJ IDEA.
 * 年度计划招聘申请同步招聘人数信息
 * @Auther: xuxy
 * @Date: 2023/11/10/10:03
 * @Description:
 */
public class SyncNdzpDataJob extends BaseCronJob {

    @Override
    public void execute() {
        new BaseBean();
        BaseBean bb = new BaseBean();
        bb.writeLog("年度计划招聘申请同步招聘人数信息！！！");
        try {
            //获取年度计划招聘申请
            RecordSet rs = new RecordSet();
            String sql = "SELECT a.nf,b.id,b.bm,b.xygw,b.xqrs,b.jhnzprs,b.jhwzprs from  uf_ndzpjhsq a  left join  uf_ndzpjhsq_dt1 b on a.id = b.mainid";
            rs.executeQuery(sql);
            bb.writeLog("SELECT uf_ndzpjhsq,uf_ndzpjhsq_dt1.sql:" + sql);
            while (rs.next()) {
                String nf = Util.null2String(rs.getString("nf"));
                String id = Util.null2String(rs.getString("id"));
                String bm = Util.null2String(rs.getString("bm"));
                String xygw = Util.null2String(rs.getString("xygw"));
                String xqrs = Util.null2String(rs.getString("xqrs"));
                String jhnzprs = Util.null2String(rs.getString("jhnzprs"));
                String jhwzprs = Util.null2String(rs.getString("jhwzprs"));
                //根据结果查询当年、部门、现有岗位的入职人数
                String str = " SELECT count(*) as num from hrmresource WHERE companystartdate=? and departmentid = ? and jobtitle = ?  ";
                bb.writeLog("SELECT hrmresource.sql:" + str);
                rs.executeQuery(str, nf, bm, xygw);
                String num = "";
                if (rs.next()) {
                    num = Util.null2String(rs.getString("num"));
                    //计算人数
                    jhnzprs = num;
                    if (Util.getIntValue(jhnzprs) > Util.getIntValue(xqrs)) {
                        jhnzprs = xqrs;
                        jhwzprs = String.valueOf(Util.getIntValue(num) - Util.getIntValue(xqrs));
                    } else {
                        jhnzprs = xqrs;
                        jhwzprs = "0";
                    }
                }
                //如果num为空，设置内外招聘人员为默认值0
                if(StringUtils.isBlank(num)){
                    jhnzprs = "0";
                    jhwzprs = "0";
                }
                //回填计划招聘人数信息到明细表
                String sql2 = "update uf_ndzpjhsq_dt1 set jhnzprs = ?,jhwzprs = ? where id = ? ";
                rs.executeUpdate(sql2, jhnzprs, jhwzprs, id);
                bb.writeLog("update uf_ndzpjhsq_dt1.sql2:" + sql2);
            }
        } catch (Exception e) {
            e.printStackTrace();
            bb.writeLog(e);
            bb.writeLog("年度计划招聘申请同步招聘人数信息--error"+e.getMessage());
        }
    }

}
